﻿using Blazorise.DataGrid;
using Microsoft.AspNetCore.Components;
using Microsoft.Extensions.Configuration.UserSecrets;
using WF_WebAdmin.Model;
using WF_WebAdmin.Service;

namespace WF_WebAdmin.Pages
{
    public partial class DeleteUser
    {
        private bool showDeletePopup = false;
        private bool showModifyPopup = false;
        private User userToDelete = null;
        private User selectedUser;
        private bool showPopupDelete = false;
        private bool showPopupAdmin = false;
        private User userToAdmin = null;
        private int MaxValue = 5;
        private int totalItem;


        [Inject]
        public HttpClient Http { get; set; }

        [Inject]
        public NavigationManager NavigationManager { get; set; }
        
        private List<User> users;
        private UserServiceStub userService;



        protected override async Task OnInitializedAsync()
        {
            userService = new UserServiceStub($"fake-dataUsers.json");
            users = await userService.GetUsersJson();
        }

        private async Task OnReadData(DataGridReadDataEventArgs<Quote> e)
        {
            if (e.CancellationToken.IsCancellationRequested)
            {
                return;
            }


            var response = await userService.getSomeUser(e.PageSize, e.Page);

            if (!e.CancellationToken.IsCancellationRequested)
            {
                totalItem = await userService.getNbUser();
                users = response.ToArray();
            }
        }

        // ------- Popup remove user -------
        private void ShowConfirmation(User user)
        {
            userToDelete = user;
            showPopupDelete = true;
        }

        private void ShowModifyConfirmation(User user)
        {
            // Afficher la modale et mémoriser l'utilisateur à supprimer
            selectedUser = user;
            showModifyPopup = true;
        }

        private async Task RemoveUser()
        {
            if (userToDelete != null)
            {
                userService = new UserServiceStub($"fake-dataUsers.json");
                await userService.DeleteUserJson(userToDelete.Id);
                ClosePopup();
            }
        }

        private async Task ModifyUser()
        {
            userService = new UserServiceStub($"fake-dataUsers.json");
            await userService.UpdateUserJson(selectedUser);
            ClosePopup();
        }

        private void ClosePopup()
        {
            showDeletePopup = false;
            showModifyPopup = false;
            showPopupDelete = false;
            showPopupAdmin = false;
        }


        // ------- Popup admin -------
        private void ShowConfirmationAdmin(User user)
        {
            userToAdmin = user;
            showPopupAdmin = true;
        }



        private async Task Admin()
        {
            if (!userToAdmin.IsAdmin)
            {
                userToAdmin.IsAdmin = true;
                ClosePopup();
            }
            else
            {
                userToAdmin.IsAdmin = false;
                ClosePopup();
            }
        }

    }
}
